
/*
 * metrics.c: this file is part of the Vectorizer project.
 *
 * Vectorizer, a vectorization module.
 *
 * Copyright (C) 2010 Louis-Noel Pouchet
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * The complete GNU Lesser General Public Licence Notice can be found
 * as the `COPYING.LESSER' file in the root directory.
 *
 * Author:
 * Louis-Noel Pouchet <pouchet@cse.ohio-state.edu>
 */
#if HAVE_CONFIG_H
# include <vectorizer/config.h>
#endif

#include <vectorizer/common.h>
#include <vectorizer/metrics.h>



s_vectorizer_metrics_t*
vectorizer_metrics_malloc ()
{
  s_vectorizer_metrics_t* ret = XMALLOC(s_vectorizer_metrics_t, 1);

  return ret;
}


void
vectorizer_metrics_free (s_vectorizer_metrics_t* metrics)
{
  int i;

  if (metrics == NULL)
    return;
}


void
vectorizer_metrics_print (FILE* file, s_vectorizer_metrics_t* metrics,
			  scoplib_scop_p scop)
{
  int i, j;
  if (metrics == NULL)
    fprintf (file, "[Vectorizer] NULL metrics\n");
}
